Index: www/xhp/ui/pager.php
new file mode 100644
===================================================================
--- www/xhp/ui/pager.php	(revision 0)
+++ www/xhp/ui/pager.php	(working copy)
@@ -0,0 +1,115 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/link.php');
+require_once(IA_ROOT_DIR . 'www/url.php');
+
+class :ui:pager extends :ui:element {
+    attribute
+        string prefix = "";
+}
+
+class :ui:pager:page-number extends :ui:pager {
+    attribute
+        int first_entry = 0,
+        int display_entries = 50,
+        int total_entries = 0,
+        int surround_pages = 5,
+        bool show_count = false,
+        bool show_display_entries = false;
+
+    protected function listPages($display_entries, $begin, $end) {
+        $list = <x:frag />;
+        for ($i = $begin; $i <= $end; ++$i) {
+            $child = <ui:link:pager first_entry={($i - 1) * $display_entries} display_entries={$display_entries} />;
+            $this -> sendAttributes($child, 'prefix');
+            $list -> appendChild($child);
+        }
+        return $list;
+    }
+
+    protected function render() {
+        $first_entry = $this -> getAttribute('first_entry');
+        $display_entries = $this -> getAttribute('display_entries');
+        $total_entries = $this -> getAttribute('total_entries');
+        $surround_pages = $this -> getAttribute('surround_pages');
+        $show_count = $this -> getAttributes('show_count');
+        $show_display_entries = $this -> getAttribute('show_display_entries');
+
+        // Setting the current page
+        $pager = <x:frag>
+                   Vezi pagina:
+                 </x:frag>;
+
+        $current_page = (int)($first_entry / $display_entries) + 1;
+        $total_pages = (int)(($total_entries - 1) / $display_entries) + 1;
+
+        // We could put a number instead of the "..."
+        if ($current_page <= 2 * $surround_pages + 1) {
+            $pager -> appendChild($this -> listPages($display_entries, 1, $current_page - 1));
+        } else {
+            $pager -> appendChild($this -> listPages($display_entries, 1, $surround_pages))
+                   -> appendChild(<x:frag> ... </x:frag>)
+                   -> appendChild($this -> listPages($display_entries, $current_page - $surround_pages, $current_page));
+        }
+
+        $pager -> appendChild(<span class="selected">
+                                <strong>
+                                  {$current_page}
+                                </strong>
+                              </span>);
+
+        if ($total_pages - $current_page <= 2 * $surround_pages) {
+            $pager -> appendChild($this -> listPages($display_entries, $current_page + 1, $total_pages));
+        } else {
+            $pager -> appendChild($this -> listPages($display_entries, $current_page + 1, $current_page + $surround_pages))
+                   -> appendChild(<x:frag> ... </x:frag>)
+                   -> appendChild($this -> listPages($display_entries, $total_pages - $surround_pages, $total_pages));
+        }
+
+        if ($show_count == true) {
+            $pager -> appendChild(<span class="count">
+                                    ({$total_entries} {$total_entries == 1 ? ' rezultat' : ' rezultate'})
+                                  </span>);
+        }
+
+        if ($show_display_entries == true) {
+            $display_entries_options = array(25, 50, 100, 250, $display_entries);
+            sort($display_entries_options);
+            $display_entries_options = array_unique($display_entries_options);
+
+            $first = true;
+            $options = <x:frag />;
+            foreach ($display_entries_options as $option) {
+                if ($first == false) {
+                   $options -> appendChild(<x:frag> | </x:frag>);
+                }
+                $first = false;
+
+                if ($option == $display_entries) {
+                    $option =
+                      <span class="selected">
+                        <strong>
+                          {$option}
+                        </strong>
+                      </span>;
+                } else {
+                    $option = <ui:link:pager display_entries={$option}>
+                                {$option}
+                              </ui:link:pager>;
+                    $this -> sendAttributes($option, array('first_entry', 'prefix'));
+                }
+
+                $options -> appendChild($option);
+            }
+
+            $pager -> appendChild(<span class="entries-per-page"> ({$options})</span>);
+        }
+        return
+          <div class="pager">
+            <div class="standard-pager">
+              {$pager}
+            </div>
+          </div>;
+    }
+}
Index: www/xhp/ui/revision-warning.php
new file mode 100644
===================================================================
--- www/xhp/ui/revision-warning.php	(revision 0)
+++ www/xhp/ui/revision-warning.php	(working copy)
@@ -0,0 +1,55 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+class :ui:revision-warning extends :ui:element {
+    attribute
+        int revision = 1,
+        int revision_count = 1,
+        string timestamp @required,
+        bool can_delete = false;
+
+    protected function render() {
+        $revision = $this -> getAttribute('revision');
+        $revision_count = $this -> getAttribute('revision_count');
+        $timestamp = $this -> getAttribute('timestamp');
+
+        $warning = <div class="warning" />;
+
+        if ($revision < $revision_count) {
+            $warning -> appendChild(<x:frag> Atenţie! Aceasta este o versiune veche a paginii </x:frag>);
+        } else {
+            $warning -> appendChild(<x:frag> Atenţie! Aceasta este ultima versiune a paginii </x:frag>);
+        }
+
+        $warning -> appendChild(<x:frag>
+                                  , scrisă la {$timestamp}
+                                  <br />
+                                </x:frag>);
+
+        if ($revision > 1) {
+            $warning -> appendChild(<ui:link href={url_textblock_revision(url_no_options(), $revision - 1)}>
+                                      Revizia anterioară
+                                    </ui:link>);
+        } else {
+            $warning -> appendChild(<x:frag> Revizia anterioară </x:frag>);
+        }
+
+
+        if ($revision < $revision_count) {
+            $warning -> appendChild(<ui:link href={url_textblock_revision(url_no_options(), $revision + 1)}>
+                                      Revizia următoare
+                                    </ui:link>);
+        } else {
+            $warning -> appendChild(<x:frag> Revizia următoare </x:frag>);
+        }
+
+
+        if ($this -> getAttribute('can_delete') == true) {
+            $warning -> appendChild(<ui:link:post href={url_textblock_delete_revision(url_no_options(), $revision)}>
+                                      Şterge
+                                    </ui:link:post>);
+        }
+    }
+}
+?>
Index: www/xhp/ui/table.php
new file mode 100644
===================================================================
--- www/xhp/ui/table.php	(revision 0)
+++ www/xhp/ui/table.php	(working copy)
@@ -0,0 +1,123 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+// If the cols attribute is missing the table will have 1 row with all the elements
+class :ui:table extends :ui:element {
+    attribute
+        :table,
+        bool header = true,
+        int cols = 0,
+        bool sortable = false;
+
+    // generates an array from all the elements
+    protected function list_elements($element) {
+        if (is_array($element)) {
+            $elements = array();
+            foreach ($element as $one) {
+                $elements = array_merge($elements, $this -> list_elements($one));
+            }
+            return $elements;
+        }
+
+        if ($element instanceof tr || $element instanceof thead || $element instanceof tbody) {
+            return $this -> list_elements($element -> getChildren());
+        }
+
+        return array($element);
+    }
+    protected function buildTable($list, $cols, $header = false, $parity = true) {
+        $rows = count($list) / $cols;
+        if (count($list) % $cols != 0) {
+            if ($header == true) {
+                $error = <th />;
+            } else {
+                $error = <td />;
+            }
+
+            $error -> setAttribute('colspan', $cols);
+            $error -> addClass('error');
+            $error -> appendChild(<x:frag> Elementele nu pot fi organizate intr-un tabel cu <strong> {$cols}
+                                      </strong> coloane.
+                                  </x:frag>);
+            return
+              <tr>
+                {$error}
+              </tr>;
+         }
+
+         $content = <x:frag />;
+
+         for ($i = 0; $i < $rows; ++$i) {
+             $row = <tr />;
+             if ($parity == true) {
+                if ($i % 2) {
+                    $row -> addClass('even');
+                } else {
+                    $row -> addClass('odd');
+                }
+             }
+
+             for ($j = 0; $j < $cols; ++$j) {
+                 if ($list[$i * $cols + $j] instanceof :td or $list[$i * $cols + $j] instanceof :th) {
+                     $row -> appendChild($list[$i * $cols + $j]);
+                 } elseif ($header == false) {
+                     $row -> appendChild(<td>
+                                           {$list[$i * $cols + $j] }
+                                        </td>);
+                 } else {
+                     $row -> appendChild(<th>
+                                           {$list[$i * $cols + $j] }
+                                         </th>);
+                 }
+             }
+             $content -> appendChild($row);
+         }
+
+         return $content;
+    }
+    protected function render() {
+        $cols = $this -> getAttribute('cols');
+        if ($cols == 0) {
+            $cols = count($this -> list_elements($this -> getChildren()));
+        }
+
+        $table = <table />;
+        $this -> sendAttributes($table);
+
+        // Making the table sortable
+        if ($this -> getAttribute('sortable') == true) {
+            $table -> addClass('sortable');
+        }
+        $children = $this -> getChildren();
+
+        $bodybegin = 0;
+        if ($this -> getAttribute('header') == true) {
+
+            if ($children[0] instanceof thead || $children[0] instanceof tr) {
+                $header = <thead>
+-                           {$this -> buildTable($children[0] -> list_elements, $cols, true, false)}
+                          </thead>;
+                $bodybegin = 1;
+            } else {
+                $header = <thead>
+                            {$this -> buildTable(array_slice($children, 0, $cols), $cols, true, false)}
+                          </thead>;
+                $bodybegin = $cols;
+            }
+        } else {
+            $header = <x:frag />;
+        }
+
+        $content = <tbody>
+                     {$this -> buildTable(array_slice($children, $bodybegin), $cols, false)}
+                   </tbody>;
+
+        // FIXME: add support for footer as it is for header
+        $footer = <tfoot />;
+
+        $table -> appendChild(array($header, $content, $footer));
+        return $table;
+    }
+}
+?>
Index: www/xhp/ui/textblock.php
new file mode 100644
===================================================================
--- www/xhp/ui/textblock.php	(revision 0)
+++ www/xhp/ui/textblock.php	(working copy)
@@ -0,0 +1,107 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/revision-warning.php');
+require_once(IA_ROOT_DIR . 'www/macros/macro_smfcomments.php');
+require_once(IA_ROOT_DIR . 'www/xhp/ui/link.php');
+
+class :ui:textblock extends :ui:element {
+    children empty;
+
+    attribute
+        :div,
+        array textblock @required,
+        bool show_forum = true,
+        int revision = 0,
+        int revision_count = 0,
+        array permitted_actions;
+
+    protected function render() {
+        $textblock = $this -> getAttribute('textblock');
+        $show_forum = $this -> getAttribute('show_forum');
+        $revision = $this -> getAttribute('revision');
+        $revision_count = $this -> getAttribute('revision_count');
+        $permitted_actions = $this -> getAttribute('permitted_actions');
+
+        $element = <x:frag />;
+
+        if (is_array($permitted_actions)) {
+            $element -> appendChild(<ui:textblock:actions textblock={$textblock}
+                                        permitted_actions={$permitted_actions} />);
+        }
+
+        // Show revision warning in case we show a revision
+        if ($revision != 0 && $revision_count != 0) {
+            $warning = <ui:revision-warning revision={$revision}
+                    revision_count={$revision}
+                    timestamp={$textblock['timestamp']} />;
+
+            if (in_array('delete-revision', $permitted_actions)) {
+                $warning -> setAttribute('can_delete', true);
+            }
+
+            $element -> appendChild($warning);
+        }
+
+        $div = <div class="wiki_text_block"> {HTML($textblock['text'])} </div>;
+        $this -> sendAttributes($div);
+
+        $element -> appendChild($div);
+
+        if ($show_forum == true && $textblock['forum_topic']) {
+            $element -> appendChild(macro_smfcommects(array('topic' => $textblock['forum_topic'],
+                                                            'display' => 'hide')));
+        }
+        return $element;
+    }
+}
+
+class :ui:textblock:actions extends :ui:element {
+    children empty;
+
+    attribute
+        array permitted_actions @required,
+        array textblock @required;
+
+    protected function render() {
+        $permitted_actions = $this -> getAttribute('permitted_actions');
+        $textblock = $this -> getAttribute('textblock');
+        $actions = <ui:list /> ;
+
+        log_print_r($permitted_actions);
+        if (in_array('edit', $permitted_actions)) {
+           $actions -> appendChild(<ui:link accesskey="e" href={url_textblock_edit($textblock['name'])}> Editează </ui:link>);
+        }
+
+        if (in_array('history', $permitted_actions)) {
+            $actions -> appendChild(<ui:link accesskey="i" href={url_textblock_history($textblock['name'])}> Istoria </ui:link>);
+        }
+
+        if (in_array('move', $permitted_actions)) {
+            $actions -> appendChild(<ui:link accesskey="u" href={url_textblock_move($textblock['name'])}> Mută </ui:link>);
+        }
+
+        if (in_array('copy', $permitted_actions)) {
+            $actions -> appendChild(<ui:link accesskey="c" href={url_textblock_copy($textblock['name'])}> Copiază </ui:link>);
+        }
+        if (in_array('delete', $permitted_actions)) {
+            $actions -> appendChild(<ui:link:post accesskey="r" href={url_textblock_delete($textblock['name'])}
+                                        confirm_request="Aceasta actiune este ireversibila! Doresti sa continui?">
+                                      Şterge
+                                    </ui:link:post>);
+        }
+        if (in_array('attach', $permitted_actions)) {
+            $actions -> appendChild(<ui:link accesskey="t" href={url_attachment_new($textblock['name'])}> Ataşează </ui:link>);
+        }
+
+        if (in_array('list-attach', $permitted_actions)) {
+            $actions -> appendChild(<ui:link accesskey="l" href={url_attachment_list($textblock['name'])}> Listează ataşamente </ui:link>);
+        }
+
+        if (count($actions -> getChildren()) == 0) {
+            return <x:frag />;
+        } else {
+            return <div id="wikiOps"> {$actions} </div>;
+        }
+    }
+}
Index: www/xhp/ui/user.php
new file mode 100644
===================================================================
--- www/xhp/ui/user.php	(revision 0)
+++ www/xhp/ui/user.php	(working copy)
@@ -0,0 +1,130 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+require_once(IA_ROOT_DIR . 'www/format/format.php');
+abstract class :ui:user extends :ui:element {
+    attribute
+        array user;
+}
+
+class :ui:user:avatar extends :ui:user {
+    attribute
+        enum { "tiny", "small", "normal", "forum", "big", "full" } size = "full";
+
+    protected function render() {
+        $user = $this -> getAttribute('user');
+        $avatar =
+          <img src={url_user_avatar($user, $this -> getAttribute('size'))}
+              alt={$user['username']} />;
+
+        return $avatar;
+    }
+}
+
+class :ui:user:rating-badge extends :ui:user {
+
+    protected function render() {
+        $user = $this -> getAttribute('user');
+        $is_admin = user_is_admin($user, false);
+        $rating = $user['rating_cache'];
+        $class = rating_group($rating, $is_admin);
+        $rating = rating_scale($rating);
+
+        if ($rating) {
+            $tag =
+              <ui:link:user page="rating" user={$user} class={'rating-badge-' . $class}
+                  title={'Rating ' . $user['username'] . ': ' . $rating}>
+                &bull;
+              </ui:link:user>;
+        } else {
+            $tag = <x:frag />;
+        }
+        return $tag;
+    }
+}
+
+class :ui:user:link extends :ui:user {
+    attribute
+        bool show_rating = true;
+
+    protected function render() {
+        $user = $this -> getAttribute('user');
+        $link =
+          <ui:link:user user={$user}>
+            {$user['full_name']}
+          </ui:link:user>;
+
+        if ($this -> getAttribute('show_rating') && !is_null($user['rating_cache'])) {
+            $link -> setAttribute('class', 'user_' . rating_group($user['rating_cache']));
+        }
+
+        if ($this -> getAttribute('show_rating')) {
+            $rating_badge = <ui:user:rating-badge user={$user} />;
+        } else {
+            $rating_badge = <x:frag />;
+        }
+
+        return
+          <x:frag>
+            {$rating_badge}
+            {$link}
+          </x:frag>;
+    }
+}
+class :ui:user:tiny extends :ui:user {
+
+    protected function render() {
+        $user = $this -> getAttribute('user');
+        $tag =
+          <x:frag>
+            <span class="tiny-user">
+              <ui:link:user user={$user}>
+                <ui:user:avatar size="tiny" />
+                {$user['full_name']}
+              </ui:link:user>
+
+              <ui:user:rating-badge user={$user}/>
+
+              <span class="username">
+                <ui:link:user user={$user}>
+                  {$user['username']}
+                </ui:link:user>
+              </span>
+
+            </span>
+          </x:frag>;
+
+       return $tag;
+    }
+}
+
+class :ui:user:normal extends :ui:user {
+
+    protected function render() {
+        $user = $this -> getAttribute('user');
+        $tag =
+          <x:frag>
+           <div class="normal-user">
+             <ui:link:user user={$user}>
+               <ui:user:avatar size="small" />
+             </ui:link:user>
+
+             <span class="fullname">
+               {$user['full_name']}
+             </span>
+
+             <br />
+
+             <ui:user:rating-badge user={$user}/>
+
+             <ui:link:user user={$user}>
+               <span class="username">
+                 {$user['username']}
+               </span>
+             </ui:link:user>
+           </div>
+         </x:frag>;
+       return $tag;
+    }
+}
+?>
